## gridtools 2.3.0

=== tests/CMakeLists.txt ===
add_library(GridToolsTest INTERFACE)
target_link_libraries(GridToolsTest INTERFACE gridtools)
target_include_directories(GridToolsTest INTERFACE include)
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(GridToolsTest INTERFACE
            $<$<COMPILE_LANGUAGE:CXX>:-Wall
            -Wno-unknown-pragmas
            -Wno-sign-compare
            -Wno-unused-local-typedefs
            -Wno-attributes
            -Wno-unused-but-set-variable
            -Wno-unneeded-internal-declaration
            -Wno-unused-function>)
    target_compile_options(GridToolsTest INTERFACE
            "$<$<COMPILE_LANGUAGE:CUDA>:SHELL:-Xcompiler
            -Wall,-Wno-unknown-pragmas,-Wno-sign-compare,-Wno-attributes,-Wno-unused-but-set-variable,-Wno-unneeded-internal-declaration,-Wno-unused-function>")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "8.4.0")
        target_compile_options(GridToolsTest INTERFACE $<$<COMPILE_LANGUAGE:CXX>:-Wno-unused-value>)
        target_compile_options(GridToolsTest INTERFACE "$<$<COMPILE_LANGUAGE:CUDA>:SHELL:-Xcompiler -Wno-unused-value>")
    endif()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "3.9.0")
        # attribute noalias has been added in clang 3.9.0
        target_compile_options(GridToolsTest INTERFACE
                $<$<COMPILE_LANGUAGE:CXX>:-Wno-unknown-attributes>)
        target_compile_options(GridToolsTest INTERFACE
                "SHELL:$<$<COMPILE_LANGUAGE:CUDA>:-Xcompiler -Wno-unknown-attributes>")
    endif()
endif()

option(GT_TREAT_WARNINGS_AS_ERROR "Treat warnings as errors" OFF)
mark_as_advanced(GT_TREAT_WARNINGS_AS_ERROR)

if(GT_TREAT_WARNINGS_AS_ERROR)
    target_compile_options(GridToolsTest INTERFACE $<$<NOT:$<COMPILE_LANGUAGE:CUDA>>:-Werror>)
endif()

## cuda support ##
if(TARGET _gridtools_nvcc)
    if(GT_TREAT_WARNINGS_AS_ERROR)
        # unfortunately we cannot treat all as warnings, we have to specify each warning; the only supported warning in CUDA8 is cross-execution-space-call
        # CUDA 9 adds deprecated-declarations (activated) and reorder (not activated)
        target_compile_options(GridToolsTest INTERFACE
                $<$<COMPILE_LANGUAGE:CUDA>:-Werror=cross-execution-space-call>
                $<$<COMPILE_LANGUAGE:CUDA>:-Xptxas=--warning-as-error>
                $<$<COMPILE_LANGUAGE:CUDA>:-Xnvlink=--warning-as-error>
                $<$<COMPILE_LANGUAGE:CUDA>:-Werror=deprecated-declarations>)
    endif()

    if (CMAKE_CUDA_COMPILER_VERSION VERSION_LESS_EQUAL 9.2)
        # suppress because of warnings in GTest
        target_compile_options(GridToolsTest INTERFACE $<$<COMPILE_LANGUAGE:CUDA>:-Xcudafe=--diag_suppress=177>)
    endif()
endif()

function(gridtools_setup_test_target tgt)
    set(options)
    set(one_value_args)
    set(multi_value_args SOURCES LIBRARIES)
    cmake_parse_arguments(ARGS "${options}" "${one_value_args}" "${multi_value_args}" ${ARGN})
    target_sources(${tgt} PRIVATE ${ARGS_SOURCES})
    target_link_libraries(${tgt} PUBLIC ${ARGS_LIBRARIES})
    target_link_libraries(${tgt} PUBLIC GridToolsTest)
    gridtools_setup_target(${tgt} CUDA_ARCH ${GT_CUDA_ARCH})
endfunction()

function(gridtools_add_test_executable tgt)
    add_executable(${tgt})
    gridtools_setup_test_target(${tgt} ${ARGN})
endfunction()


function(gridtools_add_test_library tgt)
    add_library(${tgt})
    gridtools_setup_test_target(${tgt} ${ARGN})
endfunction()

include(FetchGoogletest)
fetch_googletest()
target_link_libraries(GridToolsTest INTERFACE Threads::Threads gtest)

add_subdirectory(src)

function(gridtools_add_mpi_test arch tgt)
    set(options)
    set(one_value_args)
    set(multi_value_args SOURCES LIBRARIES LABELS)
    cmake_parse_arguments(ARGS "${options}" "${one_value_args}" "${multi_value_args}" ${ARGN})
    gridtools_add_test_executable(${tgt}
            SOURCES ${ARGS_SOURCES}
            LIBRARIES ${ARGS_LIBRARIES} mpi_gtest_main_${arch} gcl_${arch})
    set(nproc 4)
    set(labels ${ARGS_LABELS} mpi gcl ${arch})
    # Note: We use MPITEST_ instead of MPIEXEC_ because our own MPI_TEST_-variables are slurm-aware
    add_test(
            NAME ${tgt}
            COMMAND  ${MPITEST_EXECUTABLE} ${MPITEST_NUMPROC_FLAG} ${nproc} ${MPITEST_PREFLAGS} $<TARGET_FILE:${tgt}> ${MPITEST_POSTFLAGS}
    )
    set_tests_properties(${tgt} PROPERTIES LABELS "${labels}")
    set_tests_properties(${tgt} PROPERTIES PROCESSORS ${nproc})
endfunction()


add_subdirectory(regression)
add_subdirectory(unit_tests)

if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
    # Even if the explicitly requests testing, we cannot run these CMake tests as it would result in an infinite recursion.
    add_subdirectory(cmake)
endif()

=== docs_src/manuals/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SOURCEDIR     = .
BUILDDIR      = _build

# GridTools-specific install target, installs html documentation to the docs
# directory in the GridTools root director
install: html
	rm -rf ../../docs/*
	cp -r _build/html/* ../../docs

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.DEFAULT_GOAL := html

=== tests/src/CMakeLists.txt ===

if (OpenMP_CXX_FOUND)
    set(omp_ OpenMP::OpenMP_CXX)
endif()
gridtools_add_test_library(regression_main SOURCES regression_main.cpp LIBRARIES PRIVATE ${omp_})
unset(omp_)

if (TARGET gcl_cpu)
    add_library(mpi_gtest_main_cpu STATIC EXCLUDE_FROM_ALL mpi_test_driver.cpp)
    target_link_libraries(mpi_gtest_main_cpu gridtools gtest MPI::MPI_CXX)
endif()

if (TARGET gcl_gpu)
    add_library(mpi_gtest_main_gpu STATIC EXCLUDE_FROM_ALL mpi_test_driver.cpp)
    target_compile_definitions(mpi_gtest_main_gpu PRIVATE GT_HAS_CUDA)
    target_link_libraries(mpi_gtest_main_gpu PUBLIC gridtools gtest MPI::MPI_CXX)
    if(TARGET CUDA::cudart) # doesn't exist if HIP mode
        target_link_libraries(mpi_gtest_main_gpu PUBLIC CUDA::cudart)
    endif()
endif()

=== tests/regression/c_bindings/CMakeLists.txt ===
if (NOT CMAKE_C_COMPILER_LOADED AND NOT CMAKE_Fortran_COMPILER_LOADED)
    return()
endif()

include(FetchContent)
FetchContent_Declare(
        cpp_bindgen
        GIT_REPOSITORY https://github.com/GridTools/cpp_bindgen.git
        GIT_TAG        v1.0.1
)

set(build_testing_ ${BUILD_TESTING})
set(BUILD_TESTING OFF)
FetchContent_GetProperties(cpp_bindgen)
if(NOT cpp_bindgen_POPULATED)
  FetchContent_Populate(cpp_bindgen)
  add_subdirectory(${cpp_bindgen_SOURCE_DIR} ${cpp_bindgen_BINARY_DIR} EXCLUDE_FROM_ALL)
endif()
set(BUILD_TESTING ${build_testing_})

bindgen_add_library(implementation SOURCES implementation.cpp FORTRAN_MODULE_NAME implementation)
target_link_libraries(implementation PRIVATE gridtools)

if (CMAKE_C_COMPILER_LOADED)
    add_executable(driver driver.c)
    target_link_libraries(driver implementation_c)
endif()

if (CMAKE_Fortran_COMPILER_LOADED)
    bindgen_enable_fortran_library(implementation)
    add_executable(fdriver fdriver.f90)
    target_link_libraries(fdriver implementation_fortran)
    set_target_properties(fdriver PROPERTIES LINKER_LANGUAGE Fortran)

    bindgen_add_library(implementation_wrapper
            SOURCES implementation_wrapper.cpp FORTRAN_MODULE_NAME implementation_wrapper)
    target_link_libraries(implementation_wrapper PRIVATE gridtools)
    bindgen_enable_fortran_library(implementation_wrapper)

    add_executable(fdriver_wrapper fdriver_wrapper.f90)
    target_link_libraries(fdriver_wrapper implementation_wrapper_fortran)
    set_target_properties(fdriver_wrapper PROPERTIES LINKER_LANGUAGE Fortran)
endif()

=== tests/regression/py_bindings/CMakeLists.txt ===
find_package(Python3 COMPONENTS Interpreter Development NumPy)

if (NOT Python3_FOUND OR NOT Python3_Development_FOUND OR NOT Python3_NumPy_FOUND)
    return()
endif()

# This option is mostly useful if we have a broken setup
option(GT_TESTS_ENABLE_PYTHON_TESTS "Enable Python tests" ON)

if(NOT GT_TESTS_ENABLE_PYTHON_TESTS)
    return()
endif()

include(FetchContent)
FetchContent_Declare(
    pybind11
    GIT_REPOSITORY https://github.com/pybind/pybind11.git
    GIT_TAG        v2.10.0
)

FetchContent_GetProperties(pybind11)
if(NOT pybind11_POPULATED)
    FetchContent_Populate(pybind11)
    set(PYTHON_EXECUTABLE ${Python3_EXECUTABLE})
    add_subdirectory(${pybind11_SOURCE_DIR} ${pybind11_BINARY_DIR})
endif()

pybind11_add_module(py_implementation implementation.cpp)

target_link_libraries(py_implementation PRIVATE gridtools)

add_test(NAME py_bindings COMMAND ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/driver.py)

=== docs_src/manuals/getting_started/code/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18.1)

project(GridTools-laplacian LANGUAGES CXX)

set(CMAKE_CXX_EXTENSIONS OFF) # Currently required for HIP

find_package(GridTools 2.3.0 REQUIRED QUIET)

if(TARGET GridTools::stencil_cpu_ifirst)
    add_executable(gt_laplacian test_gt_laplacian.cpp)
    target_link_libraries(gt_laplacian GridTools::gridtools GridTools::stencil_cpu_ifirst)
endif()

=== debian/changelog ===
gridtools (2.3.0-2) unstable; urgency=medium

  * Push to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 11 Jun 2023 08:02:41 +0100

gridtools (2.3.0-1) experimental; urgency=medium

  * New upstream release
  * Standards-Version: 4.6.2

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 25 Apr 2023 12:03:35 +0100

gridtools (2.2.3-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 11 Mar 2023 09:51:03 +0000

gridtools (2.2.2-1) experimental; urgency=medium

  * New upstream release
  * Add Rules-Requires-Root: no

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 15 Dec 2022 14:17:13 +0000

gridtools (2.2.1-1) experimental; urgency=medium

  * New upstream release
  * Standards-Version: 4.6.1
  * Patches for additional dependencies ; use FETCHCONTENT declarations

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 24 Nov 2022 16:31:38 +0000

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
TARGET ?= $(shell dpkg-architecture -qDEB_TARGET_GNU_TYPE)
INSTDIR:=debian/libgridtools-dev
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
CMAKEDIR:=$(INSTDIR)/$(LIBDIR)/cmake

NO_NATIVE_ARCHS := powerpc ppc64el ppc64 riscv64 sh4 s390x  hppa m68k mipsel
#NATIVE :=   $(if $(filter $(DEB_TARGET_ARCH), $(NO_NATIVE_ARCHS)), \
#	 -DGT_ENABLE_BACKEND_X86=Off -DGT_ENABLE_BACKEND_NAIVE=Off ) 


BUILD_FLAGS = \
	-DCMAKE_MODULE_PATH=/usr/share/ecbuild/cmake \
	-DFETCHCONTENT_FULLY_DISCONNECTED=On \
	-DFETCHCONTENT_SOURCE_DIR_GOOGLETEST=$(CURDIR)/googletest \
	-DFETCHCONTENT_SOURCE_DIR_CPP_BINDGEN=$(CURDIR)/cpp_bindgen \
	-DFETCHCONTENT_SOURCE_DIR_PYBIND11=$(CURDIR)/pybind11 \
	-DFETCHCONTENT_QUIET=Off \
	-DGT_INSTALL_EXAMPLES_PATH=/usr/share/doc/libgridtools-dev/examples \
	$(NATIVE)

# Test suite requires 4 processors. Fake it on OpenMPI
export OMPI_MCA_rmaps_base_oversubscribe=1

%:
	dh $@ --buildsystem=ecbuild

override_dh_auto_configure:
	dh_auto_configure -- ${BUILD_FLAGS} 

override_dh_auto_test:
	@echo "Bypass tests in current builds"

override_dh_auto_install:
	dh_auto_install
	# Shuffle to correct locations
	mkdir -p $(CMAKEDIR)
	mv $(INSTDIR)/usr/lib/cmake  $(INSTDIR)/$(LIBDIR)
	sed  -i -e 's%${_IMPORT_PREFIX}/include%/usr/include%g' \
		-e 's%${PACKAGE_PREFIX_DIR}/lib/cmake%$(LIBDIR)/cmake%g' \
		$(CMAKEDIR)/GridTools/GridToolsConfig.cmake

## gridtools 2.3.1

=== docs_src/manuals/getting_started/code/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 set(CMAKE_CXX_EXTENSIONS OFF) # Currently required for HIP
 
-find_package(GridTools 2.3.0 REQUIRED QUIET)
+find_package(GridTools 2.3.1 REQUIRED QUIET)
 
 if(TARGET GridTools::stencil_cpu_ifirst)
     add_executable(gt_laplacian test_gt_laplacian.cpp)

=== debian/changelog ===
gridtools (2.3.1-1) unstable; urgency=medium

  * New upstream release
    - submodules prefetched in orig.tar tarball
  * Disable python tests as nanobind cmake appears broken

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 15 Sep 2023 11:40:43 +0100

gridtools (2.3.0-3) unstable; urgency=medium

  * g++-13 patch: Fix FTBFS with missing header. Closes: #1042232

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 27 Jul 2023 10:26:40 +0100

=== debian/control ===
Source: gridtools
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  dh-buildinfo,
  dh-sequence-fortran-mod,
  ecbuild,
  gfortran | fortran-compiler,
  python3-all,
  python3-numpy,
  pybind11-dev,
  doxygen,
  mpi-default-dev,
  libeigen3-dev,
  libgmock-dev,
  libgtest-dev,
  libboost-dev (>= 1.58.0)
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://gridtools.github.io/gridtools/latest/index.html
Vcs-Browser: https://salsa.debian.org:/science-team/gridtools.git
Vcs-Git: https://salsa.debian.org:/science-team/gridtools.git -b debian/latest

Package: libgridtools-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, 
 ecbuild, 
 mpi-default-dev,
 pybind11-dev,
 libboost-dev,
 libgtest-dev,
 libgmock-dev
Description: Framework for storage and computation on Weather and Climate Grids
 The GridTools (GT) framework is a set of libraries and utilities to develop
 performance portable applications in which stencil operations on grids are
 central.  It provides regular and block-structured grids commonly found in the
  weather and climate application field, addresses the challenges that arise
 from integration into production code, such as the expression of boundaryi
 conditions, or conditional execution. The framework is structured such that
 it can be called from different weather models or programming interfaces,
 and can target various computer architectures. This is achieved by separating
 the GT core library in a user facing part (frontend) and architecture specific
 (backend) parts. The core library also abstracts various possible data layouts
 and applies optimizations on stages with multiple stencils.
 The core library is complemented by facilities to interoperate with other 
 languages (such as C and Fortran), to aid code development and a communication
 layer.

=== debian/rules ===
--- 
+++ 
@@ -21,7 +21,9 @@
 	-DFETCHCONTENT_SOURCE_DIR_GOOGLETEST=$(CURDIR)/googletest \
 	-DFETCHCONTENT_SOURCE_DIR_CPP_BINDGEN=$(CURDIR)/cpp_bindgen \
 	-DFETCHCONTENT_SOURCE_DIR_PYBIND11=$(CURDIR)/pybind11 \
+	-DFETCHCONTENT_SOURCE_DIR_NANOBIND=$(CURDIR)/nanobind \
 	-DFETCHCONTENT_QUIET=Off \
+	-DGT_TESTS_ENABLE_PYTHON_TESTS=Off \
 	-DGT_INSTALL_EXAMPLES_PATH=/usr/share/doc/libgridtools-dev/examples \
 	$(NATIVE)

## gridtools 2.3.2

=== CMakeLists.txt ===
# GridTools CMake coding convention and architecture
# The following guide is intended for CMake developers of the GridTools library,
# users are referred to the GridTools documentation.
# - GridTools cmake modules are in
#   a) /cmake/internal: used exclusively in the GridTools CMake project
#   b) /cmake/public: need to be available in a GridTools installation
# - CMake functions are prefixed with
#   a) gridtools_: functions intended for the user (public API)
#   b) _gt_: private functions, they are not part of the public API
# - GridTools is header-only, which allows for a more flexible CMake installation compared to compiled libraries:
#   the environment from which GridTools was installed is irrelevant for the installation.
#   Therefore, we use the same macro to setup CMake targets in the main CMakeLists.txt (this file) and in the
#   GridToolsConfig.cmake of an installation (see cmake/public/gridtools_setup_target.cmake)
cmake_minimum_required(VERSION 3.18.1)
cmake_policy(VERSION 3.18.1)

file(STRINGS "version.txt" __GT_VERSION)
project(GridTools VERSION ${__GT_VERSION} LANGUAGES CXX)

message(STATUS "Configuring ${PROJECT_NAME} v${__GT_VERSION}" )

unset(__GT_VERSION)

set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CUDA_EXTENSIONS OFF)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake/public" "${CMAKE_CURRENT_LIST_DIR}/cmake/internal")

set(CMAKE_EXPORT_NO_PACKAGE_REGISTRY ON CACHE BOOL "")
mark_as_advanced(CMAKE_EXPORT_NO_PACKAGE_REGISTRY)

# User setting GT_CLANG_CUDA_MODE: decide if Clang-CUDA or NVCC
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(GT_CLANG_CUDA_MODE "AUTO" CACHE STRING
        "AUTO, Clang-CUDA or NVCC-CUDA; \
        AUTO = Use NVCC if language CUDA is enabled, else prefer Clang-CUDA.")
    set_property(CACHE GT_CLANG_CUDA_MODE PROPERTY STRINGS "AUTO;Clang-CUDA;NVCC-CUDA")
endif()

# User setting GT_INSTALL_EXAMPLES:
# if we are pointing to the default install path (usually system) we will disable installation of examples by default
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(_default_GT_INSTALL_EXAMPLES OFF)
else()
    set(_default_GT_INSTALL_EXAMPLES ON)
endif()
option(GT_INSTALL_EXAMPLES "Install example sources" ${_default_GT_INSTALL_EXAMPLES})
if(GT_INSTALL_EXAMPLES)
    set(GT_INSTALL_EXAMPLES_PATH "${CMAKE_INSTALL_PREFIX}/gridtools_examples" CACHE FILEPATH
        "Specifies where the source codes of examples should be installed")
    mark_as_advanced(CLEAR GT_INSTALL_EXAMPLES_PATH)
else()
    if(GT_INSTALL_EXAMPLES_PATH)
        mark_as_advanced(FORCE GT_INSTALL_EXAMPLES_PATH)
    endif()
endif()

set(REQUIRED_BOOST_VERSION 1.65.1)
find_package(Boost ${REQUIRED_BOOST_VERSION} REQUIRED)

# setup main gridtools target
add_library(gridtools INTERFACE)
add_library(GridTools::gridtools ALIAS gridtools)
target_compile_features(gridtools INTERFACE cxx_std_17)
target_link_libraries(gridtools INTERFACE Boost::boost)
target_compile_definitions(gridtools INTERFACE $<$<COMPILE_LANGUAGE:CUDA>:BOOST_PP_VARIADICS=1>)
target_include_directories(gridtools
        INTERFACE
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/>
        $<INSTALL_INTERFACE:include>
        )
install(TARGETS gridtools EXPORT GridToolsTargets
        INCLUDES DESTINATION include
        )

include(gridtools_setup_targets)
_gt_setup_targets(FALSE "${GT_CLANG_CUDA_MODE}")

if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
    # add a target to generate API documentation with Doxygen
    find_package(Doxygen)
    if(DOXYGEN_FOUND)
        configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
        add_custom_target(doc ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile WORKING_DIRECTORY
                ${CMAKE_CURRENT_BINARY_DIR} COMMENT "Generating API documentation with Doxygen" VERBATIM)
    endif()

    # Python scripts
    add_subdirectory(pyutils)
endif()

# Enable tests
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
    include(CTest)
else()
    # User setting GT_BUILD_TESTING: by default testing is disabled if included via FetchContent/add_subdirectory,
    # GT_BUILD_TESTING=ON will overwrite this default.
    option(GT_BUILD_TESTING "Build GridTools tests" OFF)
    if(GT_BUILD_TESTING)
        include(CTest)
    endif()
     # Note that the following is setting a local variable BUILD_TESTING, not affecting the setting of a super-project
    set(BUILD_TESTING ${GT_BUILD_TESTING})
endif()
if(BUILD_TESTING)
    set(GT_TESTS_CXX_STANDARD "DEFAULT" CACHE STRING "C++ standard for compiling tests (DEFAULT=17).")
    set_property(CACHE GT_TESTS_CXX_STANDARD PROPERTY STRINGS "DEFAULT;20")
    if(NOT GT_TESTS_CXX_STANDARD STREQUAL "DEFAULT")
        set(CMAKE_CXX_STANDARD ${GT_TESTS_CXX_STANDARD})
        set(CMAKE_CUDA_STANDARD ${GT_TESTS_CXX_STANDARD})
    endif()
    if(MPI_CXX_FOUND)
        include(workaround_mpiexec)
        _fix_mpi_exec()
    endif()

    if(TARGET _gridtools_cuda)
        if (DEFINED ENV{CUDA_ARCH})
            set(GT_CUDA_ARCH_INIT $ENV{CUDA_ARCH})
        endif()
        set(GT_CUDA_ARCH "${GT_CUDA_ARCH_INIT}" CACHE STRING "Compute capability for CUDA used for tests")

        # CMake 3.18 support for CMAKE_CUDA_ARCHITECTURES
        if(GT_CUDA_ARCH)
            gt_cuda_arch_to_cuda_arch_version(${GT_CUDA_ARCH} CMAKE_CUDA_ARCHITECTURES)
        else()
            set(CMAKE_CUDA_ARCHITECTURES OFF)
        endif()
    endif()
    include(detect_test_features)
    detect_c_compiler()
    detect_fortran_compiler()
    option(GT_TESTS_REQUIRE_OpenMP "Require OpenMP support." OFF)
    if(GT_TESTS_REQUIRE_OpenMP)
        find_package(OpenMP COMPONENTS CXX REQUIRED)
    endif()
    option(GT_TESTS_REQUIRE_GPU "Require GPU support." OFF)
    if(GT_TESTS_REQUIRE_GPU AND NOT TARGET stencil_gpu)
        message(FATAL_ERROR "GPU targets where required but we couldn't configure GPU support. Please check the CMake error logs.")
    endif()

    add_subdirectory(tests)
    add_subdirectory(docs_src/manuals/getting_started)
endif()

# examples
if(GT_INSTALL_EXAMPLES)
    add_subdirectory(examples)
endif()

# absolute path to avoid collision with "export" from other packages
include(${CMAKE_CURRENT_LIST_DIR}/cmake/internal/export.cmake)

_gt_print_configuration_summary()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -101,6 +101,21 @@
 endfunction()
 
 
+# This option is only useful if we have a broken setup,
+# where a Python environment is found but doesn't work.
+option(GT_TESTS_ENABLE_PYTHON_TESTS "Enable Python tests" ON)
+option(GT_TESTS_REQUIRE_Python "Enable Python tests" OFF)
+
+# Find Python libraries
+if (${GT_TESTS_ENABLE_PYTHON_TESTS})
+    if(GT_TESTS_REQUIRE_Python)
+        set(_GT_TESTS_Python_REQUIRED "REQUIRED")
+    endif()
+
+    find_package(Python "3.8" ${_GT_TESTS_Python_REQUIRED} COMPONENTS Interpreter Development NumPy)
+endif()
+
+
 add_subdirectory(regression)
 add_subdirectory(unit_tests)

=== tests/unit_tests/CMakeLists.txt ===
function(gridtools_check_compilation tgt)
    add_library(${tgt} OBJECT ${ARGN})
    target_link_libraries(${tgt} gridtools)
    if(TARGET _gridtools_nvcc)
        _gt_convert_to_cuda_source(sources ${ARGN})
        if (NOT sources STREQUAL ARGN)
            add_library(${tgt}_nvcc OBJECT ${sources})
            target_link_libraries(${tgt}_nvcc gridtools)
        endif()
    endif()
endfunction()

function(gridtools_add_unit_test tgt)
    set(options NO_NVCC)
    set(one_value_args)
    set(multi_value_args LIBRARIES SOURCES LABELS)
    cmake_parse_arguments(ARGS "${options}" "${one_value_args}" "${multi_value_args}" ${ARGN})
    gridtools_add_test_executable(${tgt}
            SOURCES ${ARGS_SOURCES}
            LIBRARIES gtest_main gmock ${ARGS_LIBRARIES})

    _gt_depends_on_nvcc(nvcc_compilation_checked ${tgt})

    if(NOT ARGS_NO_NVCC AND TARGET _gridtools_nvcc AND NOT nvcc_compilation_checked)
        # Additional nvcc target is created here. It exists for checking nvvc compilation only.
        # Note that it is an `OBJECT` library.
        # _gridtools_nvcc is added to deps to pickup cuda specific compilation flags.
        _gt_convert_to_cuda_source(sources ${ARGS_SOURCES})
        add_library(${tgt}_nvcc OBJECT ${sources})
        target_link_libraries(${tgt}_nvcc GridToolsTest gtest_main gmock _gridtools_nvcc ${ARGS_LIBRARIES})
    endif()

    add_test(NAME ${tgt} COMMAND $<TARGET_FILE:${tgt}>)
    set(labels unit_test ${ARGS_LABELS})
    set_tests_properties(${tgt} PROPERTIES LABELS "${labels}")
endfunction()

gridtools_check_compilation(test_meta test_meta.cpp)

add_subdirectory(common)
add_subdirectory(sid)
add_subdirectory(boundaries)
add_subdirectory(stencil)
add_subdirectory(storage)
add_subdirectory(layout_transformation)
add_subdirectory(fn)

=== docs_src/manuals/getting_started/code/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 set(CMAKE_CXX_EXTENSIONS OFF) # Currently required for HIP
 
-find_package(GridTools 2.3.1 REQUIRED QUIET)
+find_package(GridTools 2.3.2 REQUIRED QUIET)
 
 if(TARGET GridTools::stencil_cpu_ifirst)
     add_executable(gt_laplacian test_gt_laplacian.cpp)

=== tests/unit_tests/storage/adapter/CMakeLists.txt ===
include(FetchContent)
FetchContent_Declare(
        cpp_bindgen
        GIT_REPOSITORY https://github.com/GridTools/cpp_bindgen.git
        GIT_TAG        v1.0.1
)

set(build_testing_ ${BUILD_TESTING})
set(BUILD_TESTING OFF)
FetchContent_MakeAvailable(cpp_bindgen)
set(BUILD_TESTING ${build_testing_})

gridtools_add_unit_test(test_fortran_array_adapter
        SOURCES test_fortran_array_adapter.cpp
        LIBRARIES cpp_bindgen_interface
        NO_NVCC)


if (${GT_TESTS_ENABLE_PYTHON_TESTS})
        if (${Python_Development_FOUND})
                FetchContent_Declare(
                        nanobind
                        GIT_REPOSITORY https://github.com/wjakob/nanobind.git
                        GIT_TAG        v1.4.0
                )
                FetchContent_MakeAvailable(nanobind)
                nanobind_build_library(nanobind-static)

                gridtools_add_unit_test(test_nanobind_adapter
                        SOURCES test_nanobind_adapter.cpp
                        LIBRARIES nanobind-static Python::Python
                        NO_NVCC)
                nanobind_compile_options(test_nanobind_adapter)
                nanobind_link_options(test_nanobind_adapter)
        endif()
endif()

=== debian/changelog ===
gridtools (2.3.2-1) unstable; urgency=medium

  * New upstream release
  * Add dependency on fortran:Depends to libgridtools-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 08 Feb 2024 07:01:11 +0000

=== debian/control ===
--- 
+++ 
@@ -26,7 +26,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, 
+Depends: ${misc:Depends}, ${fortran:Depends},
  ecbuild, 
  mpi-default-dev,
  pybind11-dev,

=== debian/rules ===
--- 
+++ 
@@ -18,10 +18,10 @@
 BUILD_FLAGS = \
 	-DCMAKE_MODULE_PATH=/usr/share/ecbuild/cmake \
 	-DFETCHCONTENT_FULLY_DISCONNECTED=On \
-	-DFETCHCONTENT_SOURCE_DIR_GOOGLETEST=$(CURDIR)/googletest \
-	-DFETCHCONTENT_SOURCE_DIR_CPP_BINDGEN=$(CURDIR)/cpp_bindgen \
-	-DFETCHCONTENT_SOURCE_DIR_PYBIND11=$(CURDIR)/pybind11 \
-	-DFETCHCONTENT_SOURCE_DIR_NANOBIND=$(CURDIR)/nanobind \
+	-DFETCHCONTENT_SOURCE_DIR_GOOGLETEST=$(CURDIR)/_deps/googletest-src \
+	-DFETCHCONTENT_SOURCE_DIR_CPP_BINDGEN=$(CURDIR)/_deps/cpp_bindgen-src \
+	-DFETCHCONTENT_SOURCE_DIR_PYBIND11=$(CURDIR)/_deps/pybind11-src \
+	-DFETCHCONTENT_SOURCE_DIR_NANOBIND=$(CURDIR)/_deps/nanobind-src \
 	-DFETCHCONTENT_QUIET=Off \
 	-DGT_TESTS_ENABLE_PYTHON_TESTS=Off \
 	-DGT_INSTALL_EXAMPLES_PATH=/usr/share/doc/libgridtools-dev/examples \

## gridtools 2.3.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -55,7 +55,7 @@
     endif()
 endif()
 
-set(REQUIRED_BOOST_VERSION 1.65.1)
+set(REQUIRED_BOOST_VERSION 1.73)
 find_package(Boost ${REQUIRED_BOOST_VERSION} REQUIRED)
 
 # setup main gridtools target

=== tests/unit_tests/storage/adapter/CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
                 FetchContent_Declare(
                         nanobind
                         GIT_REPOSITORY https://github.com/wjakob/nanobind.git
-                        GIT_TAG        v1.4.0
+                        GIT_TAG        v2.0.0
                 )
                 FetchContent_MakeAvailable(nanobind)
                 nanobind_build_library(nanobind-static)

=== debian/changelog ===
gridtools (2.3.4-1) unstable; urgency=medium

  * Set Debian Science Maint. as maintainer
  * Fix broken vcs url
  * Standards-Version: 4.7.0; no changes required
  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 02 Jul 2024 09:33:00 +0100

## gridtools 2.3.6

=== docs_src/manuals/getting_started/code/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21.0)

project(GridTools-laplacian LANGUAGES CXX)

set(CMAKE_CXX_EXTENSIONS OFF) # Currently required for HIP

find_package(GridTools 2.3.6 REQUIRED QUIET)

if(TARGET GridTools::stencil_cpu_ifirst)
    add_executable(gt_laplacian test_gt_laplacian.cpp)
    target_link_libraries(gt_laplacian GridTools::gridtools GridTools::stencil_cpu_ifirst)
endif()

=== debian/changelog ===
gridtools (2.3.6-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 01 Nov 2024 06:43:33 +0000

gridtools (2.3.5-1) unstable; urgency=medium

  * New upstream release
  * Use dh --no-parallel to try and avoid OOM issues with g++ 14

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 08 Oct 2024 10:40:50 +0100

## gridtools 2.3.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,8 +11,8 @@
 #   the environment from which GridTools was installed is irrelevant for the installation.
 #   Therefore, we use the same macro to setup CMake targets in the main CMakeLists.txt (this file) and in the
 #   GridToolsConfig.cmake of an installation (see cmake/public/gridtools_setup_target.cmake)
-cmake_minimum_required(VERSION 3.18.1)
-cmake_policy(VERSION 3.18.1)
+cmake_minimum_required(VERSION 3.21.0)
+cmake_policy(VERSION 3.21.0)
 
 file(STRINGS "version.txt" __GT_VERSION)
 project(GridTools VERSION ${__GT_VERSION} LANGUAGES CXX)
@@ -29,12 +29,13 @@
 set(CMAKE_EXPORT_NO_PACKAGE_REGISTRY ON CACHE BOOL "")
 mark_as_advanced(CMAKE_EXPORT_NO_PACKAGE_REGISTRY)
 
-# User setting GT_CLANG_CUDA_MODE: decide if Clang-CUDA or NVCC
+# User setting GT_CLANG_CUDA_MODE: decide if Clang-CUDA, NVCC or HIP
+# TODO(havogt): rename variable to GT_CLANG_MODE in backwards compatible way
 if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
     set(GT_CLANG_CUDA_MODE "AUTO" CACHE STRING
-        "AUTO, Clang-CUDA or NVCC-CUDA; \
-        AUTO = Use NVCC if language CUDA is enabled, else prefer Clang-CUDA.")
-    set_property(CACHE GT_CLANG_CUDA_MODE PROPERTY STRINGS "AUTO;Clang-CUDA;NVCC-CUDA")
+        "AUTO, Clang-CUDA, NVCC-CUDA or HIP; \
+AUTO = Use NVCC if language CUDA is enabled, else prefer Clang-CUDA, else prefer HIP.")
+    set_property(CACHE GT_CLANG_CUDA_MODE PROPERTY STRINGS "AUTO;Clang-CUDA;NVCC-CUDA;HIP")
 endif()
 
 # User setting GT_INSTALL_EXAMPLES:

=== examples/CMakeLists.txt ===
# This file is part of the GridTools source tree to drive installation of the examples.

function(install_example)
    set(options)
    # - if needed later split into cpu and gpu sources (then add extension)
    set(one_value_args DIRECTORY)
    set(multi_value_args SOURCES)
    cmake_parse_arguments(ARG "${options}" "${one_value_args};" "${multi_value_args}" ${ARGN})

    string(REPLACE ";" " " EXAMPLES_SRCFILES "${ARG_SOURCES}")
    configure_file(cmake_skeletons/CMakeLists.txt.example.in ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${ARG_DIRECTORY}/CMakeLists.txt @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${ARG_DIRECTORY}/CMakeLists.txt DESTINATION ${GT_INSTALL_EXAMPLES_PATH}/${ARG_DIRECTORY})
    install(
        DIRECTORY ${ARG_DIRECTORY}
        DESTINATION ${GT_INSTALL_EXAMPLES_PATH}
        )

    list(APPEND enabled_examples ${ARG_DIRECTORY})
    set(enabled_examples ${enabled_examples} PARENT_SCOPE)
endfunction()

if(GT_INSTALL_EXAMPLES)
    set(enabled_examples) # used in CMakeLists.txt.in, filled in install_example()
    install_example(DIRECTORY stencil SOURCES copy_stencil horizontal_diffusion_limited tridiagonal_solver)

    configure_file(stencil_type_erasure/CMakeLists.txt.in
        ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/stencil_type_erasure/CMakeLists.txt @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/stencil_type_erasure/CMakeLists.txt
        DESTINATION ${GT_INSTALL_EXAMPLES_PATH}/stencil_type_erasure)
    install(
        DIRECTORY stencil_type_erasure
        DESTINATION ${GT_INSTALL_EXAMPLES_PATH}
        PATTERN "CMakeLists.txt.in" EXCLUDE
        )
    list(APPEND enabled_examples stencil_type_erasure)

    install_example(DIRECTORY boundaries SOURCES boundaries boundaries_provided)

    configure_file(c_bindings/CMakeLists.txt.in
        ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/c_bindings/CMakeLists.txt @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/c_bindings/CMakeLists.txt
        DESTINATION ${GT_INSTALL_EXAMPLES_PATH}/c_bindings)
    install(
        DIRECTORY c_bindings
        DESTINATION ${GT_INSTALL_EXAMPLES_PATH}
        PATTERN "CMakeLists.txt.in" EXCLUDE
        )
    list(APPEND enabled_examples c_bindings)

    configure_file(cmake_skeletons/CMakeLists.txt.driver.in ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeLists.txt @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeLists.txt DESTINATION ${GT_INSTALL_EXAMPLES_PATH})

    install(
        FILES
            ${PROJECT_SOURCE_DIR}/cmake/public/workaround_check_language.cmake
            ${PROJECT_SOURCE_DIR}/cmake/public/detect_features.cmake
            ${PROJECT_SOURCE_DIR}/cmake/public/try_compile_clang_cuda.cmake
            ${PROJECT_SOURCE_DIR}/cmake/public/try_compile_hip.cmake
        DESTINATION ${GT_INSTALL_EXAMPLES_PATH}
    )
endif()

=== tests/cmake/CMakeLists.txt ===
set(_cmake_test_root_dir ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY})

# This default test driver assumes that the project
# - is located in a subdirectory called ${name}
# - generates an executable called 'main' which exits with exit code 0 on success
function(add_cmake_test name)
    set(test_build_dir ${_cmake_test_root_dir}/${name})
    set(test_source_dir ${CMAKE_CURRENT_SOURCE_DIR}/${name})
    set(test_driver_filename ${_cmake_test_root_dir}/test_driver.${name}.sh)
    configure_file(test_driver.sh.in ${test_driver_filename} @ONLY)
    add_test(NAME cmaketest_${name}
        COMMAND /usr/bin/env sh ${test_driver_filename}
    )
    set_tests_properties(cmaketest_${name} PROPERTIES LABELS cmake)
endfunction()

if(TARGET _gridtools_cuda)
    add_cmake_test(storage_gpu)
endif()

=== _deps/cpp_bindgen-src/example/simple_fetch_content/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14.5)
project(simple_example_with_fetch_content LANGUAGES CXX Fortran)

# 1) fetch cpp_bindgen from the repository
include(FetchContent)
FetchContent_Declare(
  cpp_bindgen
  # In your application remove SOURCE_DIR ...
  SOURCE_DIR       ${CMAKE_CURRENT_LIST_DIR}/../..
  # By the following 2 lines to fetch content directly from github
  # GIT_REPOSITORY https://github.com/GridTools/cpp_bindgen.git
  # GIT_TAG        master # consider replacing master by a tagged version
)
FetchContent_MakeAvailable(cpp_bindgen)

# 2) create a library with bindings. This will generate the files simple.h and simple.f90 which can be included within C and Fortran. In CMake you can use them by linking against `simple_c`or `simple_fortran`.
bindgen_add_library(simple SOURCES simple.cpp)

# 3) link the generated library to a fortran executable
add_executable(driver driver.f90)
target_link_libraries(driver simple_fortran)

# 4) optional: demonstrates installing the library with CMake
# installs general cpp_bindgen targets
install_cpp_bindgen_targets(
  EXPORT simple_fortran_targets
  Fortran_MODULE_DESTINATION include
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  )
# install your library (simple) and the generated bindings library (simple_fortran) as usual
install(
  TARGETS simple simple_fortran
  EXPORT simple_fortran_targets
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  )
install(EXPORT simple_fortran_targets DESTINATION cmake NAMESPACE SimpleFortran::)

=== docs_src/manuals/getting_started/code/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 set(CMAKE_CXX_EXTENSIONS OFF) # Currently required for HIP
 
-find_package(GridTools 2.3.6 REQUIRED QUIET)
+find_package(GridTools 2.3.8 REQUIRED QUIET)
 
 if(TARGET GridTools::stencil_cpu_ifirst)
     add_executable(gt_laplacian test_gt_laplacian.cpp)

=== tests/unit_tests/stencil/core/CMakeLists.txt ===
gridtools_check_compilation(test_interval test_interval.cpp)
gridtools_check_compilation(test_level test_level.cpp)
gridtools_check_compilation(test_esf_metafunctions test_esf_metafunctions.cpp)
gridtools_check_compilation(test_functor_metafunctions test_functor_metafunctions.cpp)

=== tests/unit_tests/storage/adapter/CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
                 FetchContent_Declare(
                         nanobind
                         GIT_REPOSITORY https://github.com/wjakob/nanobind.git
-                        GIT_TAG        v2.0.0
+                        GIT_TAG        v2.1.0
                 )
                 FetchContent_MakeAvailable(nanobind)
                 nanobind_build_library(nanobind-static)

=== tests/unit_tests/stencil/frontend/cartesian/CMakeLists.txt ===
function(gridtools_add_cartesian_test tgt_name)
    set(options)
    set(one_value_args)
    set(multi_value_args SOURCES)
    cmake_parse_arguments(ARGS "${options}" "${one_value_args}" "${multi_value_args}" ${ARGN})
    foreach(backend IN LISTS GT_STENCILS)
        set(tgt ${tgt_name}_${backend})
        gridtools_add_unit_test(${tgt}
                SOURCES ${ARGS_SOURCES}
                LIBRARIES stencil_${backend}
                LABELS cartesian ${backend}
                NO_NVCC)
        string(TOUPPER ${backend} u_backend)
        target_compile_definitions(${tgt} PRIVATE GT_STENCIL_${u_backend})
    endforeach()
endfunction()

gridtools_check_compilation(test_call_stress_types test_call_stress_types.cpp)
gridtools_check_compilation(test_call_proc_stress_types test_call_proc_stress_types.cpp)
gridtools_check_compilation(test_arg_extent_intent test_arg_extent_intent.cpp)
gridtools_check_compilation(test_stage_with_extents test_stage_with_extents.cpp)

gridtools_add_unit_test(test_accessor SOURCES test_accessor.cpp)
gridtools_add_unit_test(test_call_interfaces SOURCES test_call_interfaces.cpp)
gridtools_add_unit_test(test_call_proc_interfaces SOURCES test_call_proc_interfaces.cpp)
gridtools_add_unit_test(test_expandable_parameters SOURCES test_expandable_parameters.cpp)
gridtools_add_unit_test(test_expressions_integration SOURCES test_expressions_integration.cpp)
gridtools_add_unit_test(test_multi_types SOURCES test_multi_types.cpp)
gridtools_add_unit_test(test_stencils SOURCES test_stencils.cpp)

gridtools_add_cartesian_test(test_kcache_fill SOURCES test_kcache_fill.cpp)
gridtools_add_cartesian_test(test_kcache_fill_and_flush SOURCES test_kcache_fill_and_flush.cpp)
gridtools_add_cartesian_test(test_kcache_flush SOURCES test_kcache_flush.cpp)
gridtools_add_cartesian_test(test_kcache_local SOURCES test_kcache_local.cpp)
gridtools_add_cartesian_test(test_kparallel SOURCES test_kparallel.cpp)

gridtools_add_unit_test(test_expressions SOURCES test_expressions.cpp NO_NVCC)

if(TARGET _gridtools_cuda)
    gridtools_add_unit_test(test_expressions_cuda SOURCES test_expressions.cu LIBRARIES _gridtools_cuda LABELS cuda)
endif()

=== debian/changelog ===
gridtools (2.3.8-1build1) questing; urgency=medium

  * No-change rebuild for gfortran 15.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Sep 2025 14:26:59 +0200

gridtools (2.3.8-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 15 Nov 2024 14:15:39 +0000

gridtools (2.3.7-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 14 Nov 2024 17:30:00 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: gridtools
 Section: science
 Priority: optional
-Maintainer: Alastair McKinstry <mckinstry@debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (= 13), 
   dh-buildinfo,
   dh-sequence-fortran-mod,
@@ -16,11 +17,11 @@
   libgmock-dev,
   libgtest-dev,
   libboost-dev (>= 1.58.0)
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://gridtools.github.io/gridtools/latest/index.html
-Vcs-Browser: https://salsa.debian.org:/science-team/gridtools.git
-Vcs-Git: https://salsa.debian.org:/science-team/gridtools.git -b debian/latest
+Vcs-Browser: https://salsa.debian.org/science-team/gridtools.git
+Vcs-Git: https://salsa.debian.org/science-team/gridtools.git -b debian/latest
 
 Package: libgridtools-dev
 Section: libdevel

=== debian/rules ===
--- 
+++ 
@@ -31,7 +31,7 @@
 export OMPI_MCA_rmaps_base_oversubscribe=1
 
 %:
-	dh $@ --buildsystem=ecbuild
+	dh $@ --buildsystem=ecbuild --no-parallel
 
 override_dh_auto_configure:
 	dh_auto_configure -- ${BUILD_FLAGS}

=== debian/watch ===
version=3
opts="uversionmangle=s/rc/~rc/, filenamemangle=s/.+\/(\d\S+)\.tar\.gz/$1\.tar\.gz/" \
  https://github.com/GridTools/gridtools/tags .*/v?(\d\S+)\.tar\.gz
